//=============================================================
//    Example Strategy based on 3 RSI indicators with different periods 
//    when all RSI exceeds MAX limit, we SELL and an active BUY is closed
//    when all RSI fall below MIN limit, we BUY and an active SELL is closed
//    Orders can be placed with and without stops
//=============================================================


int RSI_P = 14; // use 14 periods for RSI indicators

double SL = 0.002; // stop loss, 20 pips
double TP = 0.002; // take profit, 20 pips

double RSI_M1_upper_limit = 70;
double RSI_M1_lower_limit = 30;
double RSI_M5_upper_limit = 60;
double RSI_M5_lower_limit = 40;
double RSI_M15_upper_limit = 55;
double RSI_M15_lower_limit = 45;

int Lots = 1;

int init()
{
    LogPrint("Strategy initiated with RSI %i", RSI_P);
    return 0;
}

int tick()
{
    int count = GetTickCnt();
        double d1 = RSI(M1, 0);
        double d2 = RSI(M5, 0);
        double d3 = RSI(M15, 0);

//  Checking we have enough data to calculate RSI for all M intervals
    if (d1>0 && d2>0 && d3>0)  
   {
 
//LogPrint(" (Ticks Rsi M1 M5 M15) %i %i %lg %lg %lg", Bars, count, d1, d2, d3); 

if (count<400)
{
 //    LogPrint(" (Ticks Rsi M1 M5 M15) %i %i %lg %lg %lg", Bars, count, d1, d2, d3);
}

    // If we have minimum of RSI on several timeframes
    if (d1< RSI_M1_lower_limit && d2< RSI_M5_lower_limit && d3< RSI_M15_lower_limit)
    {
    //     LogPrint("Tick # %i - we are in BUY mode, ticket %i", count, Ticket);
        //    RefreshRates();
        if( Ticket == 0 && OrderType()==0) {
            // there is no active order, so we can place one   
             LogPrint("order status: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
            LogPrint("trying to place buy: (Rsi M1 M5 M15) %lg %lg %lg", d1, d2, d3);
           // Opening BUY order
           Ticket = PlaceOrder(OP_BUY, Lots, Ask, 3, Bid-SL, Ask+TP); 
//           PlaceOrder(OP_BUY, Lots, Ask, 3, 0, 0); 
            return 0;
            LogPrint("trying to place buy...");
           if (Ticket > 0 ) 
              { 
                  // BUY order fill successful
                  LogPrint("Order placed: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
              } else 
              {
                  // BUY order fill failed
                  LogPrint("BUY order placing failed");
//                  Ticket = 0;
             }
        } else if (OrderType() == OP_SELL) {
             // if we have a SELL order, time to close it when RSI is low
                 LogPrint("currently open order: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
                 LogPrint("Closing SELL ... with Ticket %i", Ticket);
                CloseOrder(Ticket); // Closing
  //                Ticket = 0;
                 LogPrint("closed order: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
             }
        }
   // If we have minimum of RSI on several timeframes
    if (d1> RSI_M1_upper_limit && d2> RSI_M5_upper_limit && d3> RSI_M15_upper_limit)
    {
 //   LogPrint("Tick #: %i we are in SELL mode, Ticket: %i", count,Ticket);
        //         LogPrint("currently open order: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
    //    RefreshRates();
       if( Ticket == 0 && OrderType()==0) {
            // there is no active order, so we can place one   
//            LogPrint("trying to place sell: (Rsi M1 M5 M15) %lg %lg %lg", d1, d2, d3);
             LogPrint("order status: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
            LogPrint("trying to place sell: Bid %lg Ask %lg TP %lg SL %lg", Bid, Ask, TP, SL);
           // Opening SELL order
           Ticket = PlaceOrder(OP_SELL, Lots, Bid, 3, Ask+SL, Bid-TP); 
  //          PlaceOrder(OP_SELL, Lots, Bid, 3, 0, 0); 
          return 0;
            LogPrint("trying to place sell: Ticket %i", Ticket);
           if (Ticket > 0 ) 
              { 
                  // BUY order fill successful
                  LogPrint("Order placed; order price %lg Lots %i type %i", OrderPrice(), OrderLots(), OrderType());
              } else 
              {
                  // BUY order fill failed
                  LogPrint("SELL order place failed");
  //               Ticket = 0;
             }
        } else  if (OrderType() == OP_BUY) {
             // if we have a BUY order, time to close it when RSI is high
                 LogPrint("currently open order: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
                 LogPrint("Closing BUY ... with Ticket %i", Ticket);
                CloseOrder(Ticket); // Closing
   //               Ticket = 0;
                 LogPrint("closed order: Ticket %i, order price %lg Lots %i type %i", Ticket, OrderPrice(), OrderLots(), OrderType());
        }
    }
  } // if all RSI values exist 
 return 0; // just waiting for enough data...
}
